package handler

import (
	"context"
	"net/http"

	httpsrv "go.unistack.org/micro-server-http/v3"
	"go.unistack.org/pkgdash/internal/models"
	pb "go.unistack.org/pkgdash/proto"
)

func (h *Handler) ModuleList(ctx context.Context, req *pb.ModuleListReq, rsp *pb.ModuleListRsp) error {
	h.logger.Debug(ctx, "Start GetModule")

	err := req.Validate()
	if err != nil {
		h.logger.Error(ctx, "validate error", err)
		httpsrv.SetRspCode(ctx, http.StatusBadRequest)
		return httpsrv.SetError(NewValidationError(err))
	}

	modules, err := h.store.ModuleList(ctx, req)
	if err != nil {
		h.logger.Error(ctx, "module list error", err)
		httpsrv.SetRspCode(ctx, http.StatusInternalServerError)
		return httpsrv.SetError(NewInternalError(err))
	}

	for _, mod := range modules {
		rsp.Modules = append(rsp.Modules, models.NewModule(mod))
	}
	h.logger.Debug(ctx, "Success finish getModule")
	return nil
}
